﻿Public Class Form1
    '*****************************************************************************************************************
    'Este complemento pasa a una obra de Presto un presupuesto escrito en una hoja de Excel.
    '*****************************************************************************************************************
    'Variables que identifican las columnas de Excel
    Public Const COL_NAT As Integer = 1
    Public Const COL_CodSup As Integer = 2
    Public Const COL_CodInf As Integer = 3
    Public Const COL_Codigo2 As Integer = 4
    Public Const COL_Resumen As Integer = 5
    Public Const COL_Ud As Integer = 6
    Public Const COL_CanPres As Integer = 7
    Public Const COL_Texto As Integer = 8
    Public Const COL_Pres As Integer = 9
    Public Const COL_Resumen2 As Integer = 10
    Public Const tblC As String = "Conceptos"
    Public Const tblR As String = "Relaciones"
    'Variable de objeto COM presto
    'Ha de estar referenciado el objeto Presto18. TypeLibrary: añádalo a la lista de referencias (Project: Add Reference)
    'Para que aparezca esta referencia, deberá haber instalado Presto 2018 y haberlo ejecutado como administrador al menos una vez
    Public po As PrestoLib.PrestoApplication
    Public MiExcel As Object 'objeto Excel
    Public wkPresto As Object 'primera hoja del libro Excel
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        APresto()
    End Sub
    Sub APresto()
        'Crea el objeto Presto
        po = CreateObject("Presto.App.18")
        With po
            'Crea el objeto Excel
            MiExcel = GetObject("C:\Temp\Presupuesto.xlsx")
            wkPresto = MiExcel.Sheets(1)

            'Crea la obra Presto
            .New("C:\Temp\" & "DeExcel" & ".Presto")
            'Empiezan el bloque de acciones que se pueden deshacer en la obra de Presto
            .BeginRedo()
            'Bloquea la visualización de la pantalla
            .SetUpdateScreen(0)
            'Establece el elemento 1, con la tabla "Conceptos" de la obra de Presto
            .SetElement(1, tblC)
            'Recorre la filas de Excel, hasta la última usada
            For y = 2 To wkPresto.UsedRange.Rows.Count
                If Not IsNothing(wkPresto.Cells(y, COL_NAT).Value) Then
                    'Va rellenando EN MEMORIA el contenido de los siguientes campos
                    .SetField(tblC & ".Nat", Val(wkPresto.Cells(y, COL_NAT).Value))
                    .SetField(tblC & ".Código", "" & wkPresto.Cells(y, COL_CodInf).Value)
                    .SetField(tblC & ".Código2", "" & wkPresto.Cells(y, COL_Codigo2).Value)
                    .SetField(tblC & ".Resumen", "" & wkPresto.Cells(y, COL_Resumen).Value)
                    .SetField(tblC & ".Ud", "" & wkPresto.Cells(y, COL_Ud).Value)
                    .SetField(tblC & ".CategoríaBIM", "" & wkPresto.Cells(y, COL_Resumen2).Value)
                    .SetField(tblC & ".Pres", wkPresto.Cells(y, COL_Pres).Value)
                    'Inserta el concepto como "de destino"
                    .SetField(tblC & ".TipoCálculo", 5, 2)
                    'Inserta EFECTIVAMENTE el registro, pasando de la memoria A LA TABLA.
                    .InsertRecord(tblC)
                    'inicializa el registro, así se evita que guarde información para el siguiente.
                    .InitRecord(tblC)

                    If .FindEqual(tblC, tblC & "." & "Código", "" & wkPresto.Cells(y, COL_CodInf).Value) = 0 Then
                        'Inserta el campo de texto
                        .SetText(tblC & ".Texto", "" & wkPresto.Cells(y, COL_Texto).Value)
                        'Inserta efectivamente el registro, pasando de la memoria a la tabla.
                        .InsertRecord(tblC)
                        'inicializa el registro, así se evita que guarde información para el siguiente.
                        .InitRecord(tblC)
                    End If
                End If
            Next
            'Establece el elemento 1, con la tabla "Relaciones" de la obra de Presto
            .SetElement(1, tblR)
            'Recorre el Excel interesándose por los campos de relaciones
            For y = 2 To wkPresto.UsedRange.Rows.Count
                .SetField(tblR & ".CodSup", "" & wkPresto.Cells(y, COL_CodSup).Value)
                .SetField(tblR & ".CodInf", "" & wkPresto.Cells(y, COL_CodInf).Value)
                If IsNumeric(wkPresto.Cells(y, COL_CanPres).Value) Then
                    .SetField(tblR & ".CanPres", CDbl(wkPresto.Cells(y, COL_CanPres).Value))
                Else
                    .SetField(tblR & ".CanPres", 0)
                End If
                'inserta EN LA TABLA
                po.InsertRecord(tblR)
                'inicializa
                po.InitRecord(tblR)
            Next
            'Desbloquea los movimientos de la pantalla
            .SetUpdateScreen(1)
            'Finaliza el bloque de acciones de que pueden deshacer en Presto
            .EndRedo()
            'Comprueba la integridad de la obra
            .CheckProject()
            'Cierra la obra
            .Close()
        End With
        Me.Close()
    End Sub
End Class
